window.forecastTab = Object.assign({}, window.forecastTab, {  
    forecastMaps: {  
        styleHandle: function(feature, context){
            // get props from hideout
	    const {bounds, colorscale, style, colorProp} = context.props.hideout;
            // get value the determines the color
            const value = feature.properties[colorProp];
	    for (let i = 0; i < bounds.length; ++i) {
		if (value > bounds[i]) {
	            // set the fill color according to the class
		    style.fillColor = colorscale[i];
		}
	    }
            return style;
        },
	pointToLayer: function(feature, latlng, context){
            const {min, max, colorscale, circleOptions, colorProp} = context.props.hideout;
            // set color based on color prop.
            circleOptions.fillColor = feature.properties[colorProp];
            // sender a simple circle marker.
            return L.circleMarker(latlng, circleOptions);
        },
	bindTooltip: function(feature, layer, context) {
            const props = feature.properties;
            // delete props.cluster;
            layer.bindTooltip(JSON.stringify(props.value), { opacity: 1.0 })
        }
    },
    wasMaps: {
        styleHandle: function(feature, context){
            // get props from hideout
	    const {bounds, colorscale, style, colorProp} = context.props.hideout;
            // get value the determines the color
            const value = feature.properties[colorProp];
	    style.fillColor = colorscale[value];
            return style;
        },
    }
});

window.evaluationTab = Object.assign({}, window.evaluationTab, {  
    evaluationMaps: {  
	pointToLayer: function(feature, latlng, context){
            const {circleOptions} = context.props.hideout;
            // sender a simple circle marker.
            return L.circleMarker(latlng, circleOptions);
        },
    }
});

window.observationsTab = Object.assign({}, window.observationsTab, {  
    observationsMaps: {  
	pointToLayer: function(feature, latlng, context){
            const {colorscale, circleOptions, colorProp} = context.props.hideout;
            const value = feature.properties[colorProp];
            circleOptions.fillColor = colorscale[value];
            // sender a simple circle marker.
            return L.circleMarker(latlng, circleOptions);
        },
    }
});

$(document).ready(function () {
    $(document).on('click', ".leaflet-popup-close-button", function () {
	elements = document.getElementsByClassName("leaflet-popup-close-button");
	
	for (let i = 0; i < elements.length; i++) {
	    var elem = elements[i];
	    // elem.replaceWith(elem.clone());
	    alert(elem.innerHTML);
	}

	alert('Closing!');
        elements[0].close();
    });
});

// Functions to fullscreen iframe
function requestFullScreen(element) {
    var requestMethod = element.requestFullScreen || element.webkitRequestFullScreen || element.mozRequestFullScreen || element.msRequestFullScreen;
    requestMethod.call(element);
}

function exitFullScreen() {
    const element = window.parent.document
    const cancelFullScreen = element.exitFullscreen || element.mozCancelFullScreen || element.webkitExitFullscreen || element.msExitFullscreen;
    cancelFullScreen.call(element);
};

// Wait for click to go fullscreen
$(document).ready(function () {
        $(document).on('click', "#fullscreen-tab", function () {
                var element = window.parent.document.getElementById('product-iframe');
                if(window.parent.document.fullscreenElement!=null){
                    console.log('Triggering exit');
                    exitFullScreen();
                }else {
                    console.log('Triggering fullscreen');
                    requestFullScreen(element);
                }
                });
});

// ==================== ROUTING FUNCTIONS =============================
// setup a dict of variables so that plain text can be entered in URL
function getVarDict() {
	const dict = {
		'AOD': 'OD550_DUST',
		'Concentration': 'SCONC_DUST',
		'Dry deposition': 'DUST_DEPD', 
		'Wet deposition': 'DUST_DEPW', 
		'Load': 'DUST_LOAD',
		'Extinction': 'DUST_EXT_SFC'
	}
	return dict
};

// get selected forecast models
$(document).ready(function () {
    $(document).on('click', "#models-apply", function () {
		//get the variable value
		curvar = document.querySelector('#react-select-2--value-item').innerHTML;
		const varDict = getVarDict(); 
		curvar = 'var=' + varDict[curvar] + '&';	

		// get models checked
		const data = [...document.querySelectorAll('.custom-control-input:checked')].map(e => e.value);
		data.forEach(function(item, index){
			this[index] = 'model=' + item
		}, data);		
		data_string = data.join('&');
		console.log(data_string);

		//convert to the output URL
		url = "/dashboard/?" + curvar + data_string;
		window.history.pushState("object or string", "Title", url);
		//window.history.pushState('Updated', url);
	})	
});

